'DotNetNuke -  http://www.dotnetnuke.com
' Countdown Module - http://www.boul.nl
' Copyright (c) 2002-2003
' by Roeland Kuipers - http://www.boul.nl
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
' Roeland Kuipers (http://www.boul.nl) 18-05-2003 - Countdown Module build based on the webtoolbox.countdown assembly (by http://www.salimnaim.com)
' Roeland Kuipers (http://www.boul.nl) 26-05-2003 - Countdown Module v2.0.1 completely rewritten to get rid of the webtoolbox assembly! + added functionality
' Roeland Kuipers (http://www.boul.nl) 02-06-2003 - Countdown Module v2.1.0 timezone support added, to the hour/minute exact countdown & fixed some minor bugs.
'Roeland Kuipers (http://www.boul.nl) 27-08-2003 - Countdown Module v2.2.0 countup support added, it's no possible to let the the counter expire or continue to countup!
Namespace DotNetNuke
    Public MustInherit Class Countdown


        Inherits PortalModuleControl

        Protected WithEvents cdDay2 As System.Web.UI.WebControls.Label
        Protected WithEvents cdDay1 As System.Web.UI.WebControls.Label
        Protected WithEvents cdDay0 As System.Web.UI.WebControls.Label
        Protected WithEvents cdHour1 As System.Web.UI.WebControls.Label
        Protected WithEvents cdHour0 As System.Web.UI.WebControls.Label
        Protected WithEvents cdMinute1 As System.Web.UI.WebControls.Label
        Protected WithEvents cdMinute0 As System.Web.UI.WebControls.Label
        Protected WithEvents cdSecond1 As System.Web.UI.WebControls.Label
        Protected WithEvents cdSecond0 As System.Web.UI.WebControls.Label
        Protected WithEvents labErrorMessage As System.Web.UI.WebControls.Label
        Protected WithEvents lbldays As System.Web.UI.WebControls.Label
        Protected WithEvents lblHrs As System.Web.UI.WebControls.Label
        Protected WithEvents lblMins As System.Web.UI.WebControls.Label
        Protected WithEvents lblSecs As System.Web.UI.WebControls.Label
        Protected WithEvents lblScript As System.Web.UI.WebControls.Label
        Protected WithEvents labCountdownText As System.Web.UI.WebControls.Label



#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

           
            Dim intYear, intMonth, intDay, intHour, intMinute, intTimezone As Integer
            Dim StrTargetDate As String
            Dim ImgSrc As String
            Dim ImgPrefix As String
            Dim ImgExt As String
            Dim CntDwnMode As String
            Dim CntDwnTxt As String
            Dim strScriptSrc As String
            Dim ScriptSrc As String
            Dim CurrentDate As DateTime
            Dim StrCurrentDate As String
            Dim txtExpired As String
            Dim strTimeZone As String
            Dim strCntDwnExpire As String


            ImgSrc = CType(Settings("CntDwnImgSrc"), String)
            ImgPrefix = CType(Settings("CntDwnImgPrefix"), String)
            ImgExt = CType(Settings("CntDwnImgExt"), String)
            CntDwnMode = CType(Settings("CntDwnMode"), String)
            intYear = CType(Settings("CntDwnYear"), Integer)
            intMonth = CType(Settings("CntDwnMonth"), Integer)
            intDay = CType(Settings("CntDwnDay"), Integer)
            intHour = CType(Settings("CntDwnHour"), Integer)
            intMinute = CType(Settings("CntDwnMinute"), Integer)
            intTimeZone = CType(Settings("CntDwnTimeZone"), Integer)
            CntDwnTxt = CType(Settings("CntDwnText"), String)
            txtExpired = CType(Settings("CntDwnExpired"), String)
            ScriptSrc = CType(Settings("CntDwnScriptSrc"), String)
            strTimeZone = CType(Settings("CntDwnTimeZone"), Integer)
            strCntDwnExpire = CType(Settings("CntDwnExpire"), String)

            labCountdownText.Text = CntDwnTxt
            CurrentDate = DateTime.Now

            'Check if the database already contains Date data
            If intYear + intMonth + intDay = 0 Then

                DrawCounter(ImgSrc, ImgPrefix, ImgExt) 'Draw fixed counter only 8's in the display.
                labErrorMessage.Text = "Please configure me ;-)"

            Else
                'Check if date is not in the paste if so throw a error!
                Dim CountDownDate As New DateTime(intYear, intMonth, intDay, intHour, intMinute, 0)
                If DateTime.Compare(CountDownDate, CurrentDate) <= 0 Then

                    'Check if the counter must expire
                    If strCntDwnExpire = "True" Then
                        DrawCounter(ImgSrc, ImgPrefix, ImgExt)
                        labErrorMessage.Text = txtExpired
                        labCountdownText.Visible = False
                    Else
                        DrawCounter(ImgSrc, ImgPrefix, ImgExt)
                        labCountdownText.Text = txtExpired
                        'Because the Countdown target date has expired and the counter must continue (to count up!) we have to use countup scripts
                        'Instead of countdown scripts
                        'Check if client-side or server-side time is selected and adjust the script variables accordingly
                        If CntDwnMode = "ClientSide" Then

                            strScriptSrc = "<script language=""javascript"" src=" & Chr(34) & ScriptSrc & "cntupclient.js""></script>"

                            'labCurrentDate.Visible = False
                        Else

                            strScriptSrc = "<script language=""javascript"" src=" & Chr(34) & ScriptSrc & "cntupserver.js""></script>"

                            StrCurrentDate = CurrentDate.ToString("yyyy, M , d, H, m ,s")

                        End If

                        StrTargetDate = CountDownDate.ToString("yyyy, M, d, H, m, s")
                        'Everything seems ok so draw the counter!
                        DrawCounter(ImgSrc, ImgPrefix, ImgExt, StrTargetDate, StrCurrentDate, strScriptSrc, strTimeZone)
                    End If


                Else
                    'Since the targetdate hasn't expired yet we still have to countdown!
                    'Check if client-side or server-side time is selected and adjust the script variables accordingly
                    If CntDwnMode = "ClientSide" Then

                        strScriptSrc = "<script language=""javascript"" src=" & Chr(34) & ScriptSrc & "cntdwnclient.js""></script>"

                        'labCurrentDate.Visible = False
                    Else

                        strScriptSrc = "<script language=""javascript"" src=" & Chr(34) & ScriptSrc & "cntdwnserver.js""></script>"

                        StrCurrentDate = CurrentDate.ToString("yyyy, M , d, H, m ,s")

                    End If

                    StrTargetDate = CountDownDate.ToString("yyyy, M, d, H, m, s")
                    'Everything seems ok so draw the counter!
                    DrawCounter(ImgSrc, ImgPrefix, ImgExt, StrTargetDate, StrCurrentDate, strScriptSrc, strTimeZone)


                End If
                End If
        End Sub

        Private Sub DrawCounter(ByVal ImgSrc As String, ByVal ImgPrefix As String, ByVal ImgExt As String, Optional ByVal TargetDate As String = "", Optional ByVal CurrentDate As String = "", Optional ByVal strScriptSrc As String = "", Optional ByVal TimeZone As String = "")
            Dim strScriptStart, strScriptEnd, strImageSrc, strImagePrefix, strImageExt, strTargetDate, strCurrentDate, strTimezone As String

            If ImgSrc = "" Then

                Dim myPath As String = Request.ServerVariables("PATH_INFO")
                myPath = myPath.ToLower.Replace("desktopdefault.aspx", "desktopmodules/countdown/")
                ImgSrc = myPath
                'ImgSrc = "/desktopmodules/countdown/"
            End If

            If ImgPrefix = "" Then
                ImgPrefix = "CntDwn"
            End If

            If ImgExt = "" Then
                ImgExt = ".gif"
            End If

            strScriptStart = "<script language=""javascript"">"
            strScriptEnd = "</script>"
            strImageSrc = "var ImgSrc = " & Chr(34) & ImgSrc & Chr(34) & ";"
            strImagePrefix = "var ImgPrefix = " & Chr(34) & ImgPrefix & Chr(34) & ";"
            strImageExt = "var ImgExt = " & Chr(34) & ImgExt & Chr(34) & ";"
            strTargetDate = "var nTarget = Date.UTC(" & TargetDate & ");"
            strCurrentDate = "var dNow = new Date(" & CurrentDate & ");"
            strTimezone = "var TimeZone = " & TimeZone & ";"

            cdDay0.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdDay0"">"
            cdDay1.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdDay1"">"
            cdDay2.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdDay2"">"
            cdHour0.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdHour0"">"
            cdHour1.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdHour1"">"
            cdMinute0.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdMinute0"">"
            cdMinute1.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdMinute1"">"
            cdSecond0.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdSecond0"">"
            cdSecond1.Text = "<IMG height=""23"" src=" & Chr(34) & ImgSrc & ImgPrefix & "8" & ImgExt & Chr(34) & " width=""14"" name=""cdSecond1"">"

            'labImgSrc.Text = "<script language=""javascript"">var ImgSrc = " & Chr(34) & ImgSrc & Chr(34) & ";</script>"
            'labImgPrefix.Text = "<script language=""javascript"">var ImgPrefix = " & Chr(34) & ImgPrefix & Chr(34) & ";</script>"
            'labImgExt.Text = "<script language=""javascript"">var ImgExt = " & Chr(34) & ImgExt & Chr(34) & ";</script>"

            If Not strTargetDate = "" Then
                ' labTargetDate.Text = "<script language=""javascript"">var nTarget = Date.UTC(" & TargetDate & ");</script>"
                ' labCurrentDate.Text = "<script language=""javascript"">var dNow = new Date(" & CurrentDate & ");</script>"
                ' labScriptSource.Text = strScriptSrc
                lblScript.Text = strScriptStart + strImageSrc + strImageExt + strImagePrefix + strTargetDate + strCurrentDate + strTimezone + strScriptEnd + strScriptSrc
            Else
                lblScript.Text = strScriptStart + strImageSrc + strImageExt + strImagePrefix + strScriptEnd
            End If
        End Sub


    End Class
End Namespace
